﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NetworkBuilder
{
    public class Helper
    {
        public static string ListToString(IList<string> l)
        {
            if (l == null) return "";
            if (l.Count == 0) return "";
            StringBuilder sb = new StringBuilder();
            sb.Append(l[0].Trim().Trim('\"').Trim());
            for (int i = 1; i < l.Count; i++)
            {
                if (l[i].Trim().Trim('\"').Trim() != "")
                {
                    sb.Append(";");
                    sb.Append(l[i].Trim().Trim('\"').Trim());
                }
            }
            return sb.ToString();
        }

        public static string GetKey(long id1, long id2)
        {
            string key = String.Format("{0}-{1}", id1, id2);
            if (id1 < id2)
            {
                key = String.Format("{0}-{1}", id2, id1);
            }
            return key;
        }

        public static IList<long> AllPathogens(IList<Node> nodes)
        {
            IList<long> l = new List<long>();

            foreach (Node n in nodes)
            {
                foreach (long p in n.Pathogens)
                {
                    if (!l.Contains(p))
                        l.Add(p);
                }
            }
            return l;
        }
        public static IList<long> AllNodes(IList<Node> nodes)
        {
            IList<long> l = new List<long>();

            foreach (Node n in nodes)
            {
                if (!l.Contains(n.EID2ID))
                    l.Add(n.EID2ID);
            }
            return l;
        }

        public static IList<long> SharedPathogens(IList<Edge> edges)
        {
            IList<long> l = new List<long>();

            foreach (Edge e in edges)
            {
                foreach (long p in e.Pathogens)
                {
                    if (!l.Contains(p))
                        l.Add(p);
                }
            }
            return l;
        }

        public static IList<long> GetPathogens(string s)
        {
            IList<long> l = new List<long>();
            string[] items = s.Split(';');
            foreach (string i in items)
            {
                if (i != "")
                {
                    l.Add(Convert.ToInt64(i));
                }
            }
            return l;
        }

        public static int IndexOfNode(IList<Node> nodes, long id)
        {
            for (int i = 0; i < nodes.Count; i++)
            {
                if (nodes[i].EID2ID == id)
                    return i;
            }

            return -1;
        }

    }
}
