﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NetworkBuilder
{
    public class PathogensExtractor
    {

        public static string[] PathogenPotentialSubTypes(string pathogenType)
        {
            switch (pathogenType)
            {
                case "virus":
                    string[] v = { "dna", "rna" };
                    return v;
                case "bacteria":
                    string[] b2 = { "gram-negative", "gram-positive"};
                    return b2;

            }
            return null;
        }


        public static IList<long> ExtractSubType(string pathogenType,  string subtype_input) //levels = 1, 2, 3
        {
            if (pathogenType == subtype_input)
                return (ExtractType(pathogenType));

            string[] data = File.ReadAllLines(Globals.PathogensClassification);
            IList<long> l = new List<long>();
            for (int i = 1; i < data.Length; i++)
            {
                string[] items = data[i].ToLower().Split('\t');
                int include = Convert.ToInt32(items[9].Trim());
                if (include == 1)
                {
                    string type = items[5].Trim().Trim('\"').Trim();
                    if (type == pathogenType)
                    {
                        string subtype = items[7].Trim().Trim('\"').Trim();                        
                        if (subtype == subtype_input)
                        {
                            long key = Convert.ToInt64(items[1].Trim());
                            if (!l.Contains(key))
                            {
                                l.Add(key);
                            }
                        }
                    }
                }

            }
            return l;
        }


        public static IList<long> ExtractType(string pathogentype)
        {
            if (pathogentype == "all") return ExtractProperPathogens();
            string[] data = File.ReadAllLines(Globals.PathogensClassification);
            IList<long> l = new List<long>();

            for (int i = 1; i < data.Length; i++)
            {
                string[] items = data[i].ToLower().Split('\t');
                int include = Convert.ToInt32(items[9].Trim());
                if (include == 1)
                {
                    string type = items[5].Trim().Trim('\"').Trim();
                    if (type == pathogentype)
                    {
                        long key = Convert.ToInt64(items[1].Trim());
                        if (!l.Contains(key))
                        {
                            l.Add(key);
                        }
                    }
                }

            }
            return l;
        }


        public static IList<long> ExtractProperPathogens()
        {
            string[] data = File.ReadAllLines(Globals.PathogensClassification);
            IList<long> l = new List<long>();
            for (int i = 1; i < data.Length; i++)
            {
                string[] items = data[i].ToLower().Split('\t');
                int include = Convert.ToInt32(items[9].Trim());
                if (include == 1)
                {
                    long key = Convert.ToInt64(items[1].Trim());
                    if (!l.Contains(key))
                    {
                        l.Add(key);
                    }
                }

            }
            return l;
        }
    }
}
