﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace NetworkBuilder
{
    class Program
    {
        static void Main(string[] args)
        {
            string edges_file = String.Format(@"{0}/edges.csv", IOHelper.GenerateNetworkFolder("V", "S"));

            IDictionary<string, int> PathogensTaxonomicDistances = TraitsProcessor.GetPathogenTaxDistances();
            string[] P = { "bacteria", "virus", "helminth", "protozoa", "all" }; //
            foreach (string p in P)
            {
                if (p == "bacteria" || p == "virus")
                {
                    string[] substypes = PathogensExtractor.PathogenPotentialSubTypes(p);
                    foreach (string st in substypes)
                    {
                        NetworkBuilder.GenerateNetwork(p, st, PathogensTaxonomicDistances);
                        //Randomiser.Run(p, st);
                    }
                }
                NetworkBuilder.GenerateNetwork(p, p, PathogensTaxonomicDistances);
                //Randomiser.Run(p, p);
            }
        }
    }
}
