﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace NetworkBuilder
{
    public class TraitsProcessor
    {
        public static IList<long> GetHumanPathogen(string PathogenType)
        {
            string input = Globals.VertebratesDataSet;
            string[] Data = File.ReadAllLines(input);

            IList<long> l = new List<long>();
            for (int i = 1; i < Data.Length; i++)
            {
                string[] items = Data[i].ToLower().Split('\t');
                long EID2ID = Convert.ToInt64(items[8].Trim('\"').Trim());
                long pathogen = Convert.ToInt64(items[2].Trim('\"').Trim());
                string pc = items[6].Trim('\"').Trim();
                string hc1 = items[11].Trim('\"').Trim();

                if (hc1 == "human")
                {
                    if (PathogenType == "" || PathogenType == "all" || pc == PathogenType)
                    {
                        if (!l.Contains(pathogen))
                            l.Add(pathogen);
                    }
                }

            }

            return l;
        }
        public static IDictionary<long, string> OrderFamily(int index) //0, 1, 2, 3 ,4 
        {

            string input = Globals.OrdersFamilies;
            string[] data = File.ReadAllLines(input);
            IDictionary<long, string> dic = new Dictionary<long, string>();

            for (int i = 1; i < data.Length; i++)
            {
                try
                {
                    string[] items = data[i].ToLower().Split('\t');

                    long key = Convert.ToInt64(items[1].Trim());
                    string value = items[index].Trim().Trim('\"').Trim();
                    if (value != "")
                    {
                        if (!dic.ContainsKey(key))
                        {
                            dic.Add(key, value);
                        }
                    }
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                }
            }
            return dic;
        }
        public static IDictionary<string, int> GetPathogenTaxDistances()
        {
            IDictionary<string, int> dic = new Dictionary<string, int>();
            string[] Data = File.ReadAllLines(Globals.PathogensTaxDistancesDataset);
            for (int i = 1; i < Data.Length; i++)
            {
                try
                {
                    string[] items = Data[i].Split('\t');
                    long id1 = Convert.ToInt64(items[0].Trim());
                    long id2 = Convert.ToInt64(items[1].Trim());
                    int distance = Convert.ToInt32(items[2].Trim());

                    string key = Helper.GetKey(id1, id2);
                    if (!dic.ContainsKey(key))
                        dic.Add(key, distance);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                }
            }
            return dic;
        }
        public static IDictionary<string, int> GetPathogenTaxDistances(IList<long> pathogens)
        {
            IDictionary<string, int> dic = new Dictionary<string, int>();
            string[] Data = File.ReadAllLines(Globals.PathogensTaxDistancesDataset);
            for (int i = 1; i < Data.Length; i++)
            {
                try
                {
                    string[] items = Data[i].Split('\t');
                    long id1 = Convert.ToInt64(items[0].Trim());
                    long id2 = Convert.ToInt64(items[1].Trim());
                    if (pathogens.Contains(id1) && pathogens.Contains(id2))
                    {
                        int distance = Convert.ToInt32(items[2].Trim());

                        string key = Helper.GetKey(id1, id2);
                        if (!dic.ContainsKey(key))
                            dic.Add(key, distance);
                    }
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                }
            }
            return dic;
        }


    }
}
